'From Squeak3.7 of ''4 September 2004'' [latest update: #5989] on 28 April 2008 at 11:00:18 pm'!

!CompositeLW methodsFor: 'submorphs-accessing' stamp: 'jmv 4/28/2008 22:49'!
morphsAt: aPoint behind: aMorph unlocked: aBool 
	"Return all morphs at aPoint that are behind frontMorph; if aBool is true return only unlocked, visible morphs."

	| isBack found all tfm |
	all := (aMorph isNil or: [owner isNil]) 
				ifTrue: 
					["Traverse down"

					(self fullBounds containsPoint: aPoint) ifFalse: [^#()].
					(aBool and: [self isLocked or: [self visible not]]) ifTrue: [^#()].
					nil]
				ifFalse: 
					["Traverse up"

					tfm := self transformedFrom: owner.
					all := owner 
								morphsAt: (tfm localPointToGlobal: aPoint)
								behind: self
								unlocked: aBool.
					WriteStream with: all].
	isBack := aMorph isNil.
	self submorphsDo: 
			[:m | 
			isBack 
				ifTrue: 
					[tfm := m transformedFrom: self.
					found := m 
								morphsAt: (tfm globalPointToLocal: aPoint)
								behind: nil
								unlocked: aBool.
					found notEmpty 
						ifTrue: 
							[all ifNil: [all := WriteStream on: #()].
							all nextPutAll: found]].
			m == aMorph ifTrue: [isBack := true]].
	(isBack and: [self containsPoint: aPoint]) 
		ifTrue: 
			[all ifNil: [^Array with: self].
			all nextPut: self].
	^all ifNil: [#()] ifNotNil: [all contents]! !

!classDefinition: #LightWidget category: #'LightWidgets-Kernel'!
Object subclass: #LightWidget
	instanceVariableNames: 'owner bounds model modelUpdateSelector isVisible'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LightWidgets-Kernel'!

!ButtonLW methodsFor: 'initialization' stamp: 'jmv 4/28/2008 22:52'!
initialize
	super initialize.
	model _ 'I am the model'.
	modelUpdateSelector _ #show.
	bounds _ 10@10 extent: 60@30.
	label _ 'button label'.
	font _ (TextStyle named: 'Vera') fontNamed: 'Vera 16'.
	pressed _ false! !


!LightWidget methodsFor: 'initialization' stamp: 'jmv 4/28/2008 22:53'!
initialize
	super initialize.
	isVisible _ true.
	bounds _ 10@10 extent: 40@30! !


!LabelLW methodsFor: 'initialization' stamp: 'jmv 4/28/2008 22:53'!
initialize
	super initialize.
	bounds _ 10@10 extent: 60@30.
	label _ 'label'.
	font _ self defaultFont! !


!MenuItemLW methodsFor: 'initialization' stamp: 'jmv 4/28/2008 22:54'!
initialize
	super initialize.
	bounds _ 10@10 extent: 100@30.
	label _ 'item text'! !


!LightWidget methodsFor: 'defaults' stamp: 'jmv 4/28/2008 22:54'!
defaultFont
	^StrikeFont familyName: 'Vera' size: 28! !


!LightWidget methodsFor: 'drawing' stamp: 'jmv 4/28/2008 22:55'!
visible
	^isVisible! !


!LightWidget methodsFor: 'drawing' stamp: 'jmv 4/28/2008 22:56'!
hide
	owner ifNil: [^ self].
	self visible ifTrue: [self visible: false.  self changed]! !


!LightWidget methodsFor: 'drawing' stamp: 'jmv 4/28/2008 22:56'!
show
	"Make sure this morph is on-stage."
	self visible ifFalse: [self visible: true.  self changed]! !


!LightWidget methodsFor: 'drawing' stamp: 'jmv 4/28/2008 22:57'!
visible: aBoolean 
	"set the 'visible' attribute of the receiver to aBoolean"
	isVisible == aBoolean
		ifTrue: [^ self].
	isVisible _ aBoolean.
	self changed! !

